/*
 * Params:
 * url: url called via http delete (required)
 * name: name to show in dialog
 */
lm.component('commonDialogDelete', {
	templateUrl: 'comp/common/commonDialogDelete.' + lmCacheTag + 'html',
	bindings: { lmParams: '<', lmDismiss: '&', lmDone: '&' },
	controller: function($http, serviceLimboMedia) {
		var ctrl = this;

		ctrl.working = false;
		
		ctrl.$onInit = function() {
			if(!ctrl.lmParams.url) {
				console.log("No url param. Closing.");
				ctrl.lmDismiss();
				return;
			}
			if(!ctrl.lmParams.name) {
				console.log("No name param. Closing.");
				ctrl.lmDismiss();
				return;
			}
		}
		
		ctrl.ok = function() {
			ctrl.working = true;
			
			$http.delete(ctrl.lmParams.url).then(
				function success(resp) {
					ctrl.lmDone();
				},
				function error(resp) {
					serviceLimboMedia.handleHttpErrorNew(resp);
					ctrl.working = false;
				}
			);
		};
		
	}
});
