/*
 * Params:
 * id: file id (required)
 */
lm.component('fileDialogFileLinks', {
	templateUrl: 'comp/file/fileDialogFileLinks.' + lmCacheTag + 'html',
	bindings: { lmParams: '<', lmDismiss: '&', lmDone: '&' },
	controller: function($http, serviceLimboMedia) {
		var ctrl = this;

		ctrl.earl = lmBase.urlFull + lmBase.url;

		ctrl.file = null;
		ctrl.authtoken = null;
		ctrl.linkOriginal = null;
		
		ctrl.video = {
			linkVideo: '',
			videoFormats: ['WEBM','MP4'],
			videoTranss: ['P360','P720','P1080'],
			videoFormat: 'WEBM',
			videoTrans: 'P360',
			videoAudios: [],
			videoAudio: null,
			trancoding: false,
			timeStarts: [],
			timeStart: 0
		}		
		
		ctrl.$onInit = function() {
			/* load file details */
			$http.get(lmBase.url + 'f/file/' + ctrl.lmParams.id + '?details=true').then(
				function success(resp) {
					ctrl.file = resp.data;
					ctrl.aquireToken();
				},
				serviceLimboMedia.handleHttpErrorNew
			);			
		};
		
		ctrl.aquireToken = function() {
			$http.get(lmBase.url + 'f/file/' + ctrl.file.id + '/token').then(
				function success(resp) {
					ctrl.authtoken = resp.data.id;
					ctrl.buildlinks();
				},
				serviceLimboMedia.handleHttpErrorNew
			);
		};		
		
		ctrl.buildlinks = function() {
			ctrl.linkOriginal = ctrl.earl + 'f/stream/' + ctrl.file.id + '/' + encodeURIComponent(ctrl.file.name) + '?token=' + ctrl.authtoken;
			
			if("VIDEO" == ctrl.file.type) {
				/* extract audios */
				ctrl.video.videoAudios = ctrl.file.formatOriginal.streams.filter(function(val) {
					return val.type == "AUDIO";
				});
				
				/* build start at options */
				var parts = 20;
				var partLength = ctrl.file.duration / parts;
				for(var i = 0; i < parts; i++) {
					var part = Math.floor(partLength * i);
					ctrl.video.timeStarts.push(part);
				}
				
				ctrl.onVideoFormatChange();
			}
		};
		
		ctrl.onVideoFormatChange = function() {
			ctrl.video.transcoding = ctrl.file.formats.filter(function(valFormat) {
				return ctrl.video.videoFormat == valFormat.standard && ctrl.video.videoTrans == valFormat.layout; 
			}).length == 0;

			ctrl.video.videoAudio = ctrl.video.transcoding && ctrl.video.videoAudios.length > 1 ? ctrl.video.videoAudios[0] : null;
			ctrl.video.timeStart = 0;
			
			ctrl.buildVideoLink();
		}
		
		ctrl.buildVideoLink = function() {
			var filebase = ctrl.file.name.replace(lmBase.reExt,'');
			if(filebase.length == 0) filebase = 'x';
			filebase = encodeURIComponent(filebase);
			var ext = ctrl.video.videoFormat == 'WEBM' ? '.webm' : '.mp4';
			var atrack = ctrl.video.videoAudio == null ? '' : ('&sau=' + ctrl.video.videoAudio.idx);
			var ss = ctrl.video.timeStart == 0 ? '' : ('&ss=' + ctrl.video.timeStart);
			ctrl.video.linkVideo = ctrl.earl + 'f/streamVideo/' + ctrl.file.id + '/' + filebase + '_' + ctrl.video.videoTrans + ext + '?token=' + ctrl.authtoken + '&standard=' + ctrl.video.videoFormat + '&layout=' + ctrl.video.videoTrans + atrack + ss;
		}
		
		ctrl.removetranscoding = function(valuetrans) {
			var idx = ctrl.transcodings.indexOf(valuetrans);
			if(idx != -1) ctrl.transcodings.splice(idx, 1);
		};		
		
	}
});
