/*
 * Params:
 * id: File ID (Otional. Given=Edit, Left=Create with folderId required)
 * folderId: Folder ID where new link should be saved.
 * Output:
 * result: file
 */
lm.component('fileDialogFileTaskEdit', {
	templateUrl: 'comp/file/fileDialogFileTaskEdit.' + lmCacheTag + 'html',
	bindings: { lmParams: '<', lmDismiss: '&', lmDone: '&' },
	controller: function($element, $http, serviceLimboMedia, serviceNotification) {
		var ctrl = this;

		ctrl.file = null;
		ctrl.folderId = null;

		/* Use dialog itself as backdrop for popper. */
		ctrl.elementOutside = $element.get(0);
		
		ctrl.$onInit = function() {
			if(ctrl.lmParams.id) {
				$http.get(lmBase.url + 'f/file/' + ctrl.lmParams.id).then(
					function success(resp) {
						ctrl.file = resp.data;
					},
					serviceLimboMedia.handleHttpErrorNew
				);
			}
			else {
				ctrl.file = {title: '', done: false};
				ctrl.folderId = ctrl.lmParams.folderId;
			}
		};
		
		ctrl.save = function() {
			if(ctrl.folderId) {
				var req = {title: ctrl.file.title, done: ctrl.file.done, folderId: ctrl.folderId};
				$http.post(lmBase.url + 'f/task', req).then(
					function success(resp) {
						ctrl.lmDone({result: resp.data});
					},
					serviceLimboMedia.handleHttpErrorNew
				);
			}
			else {
				var req = {title: ctrl.file.title, done: ctrl.file.done};
				$http.post(lmBase.url + 'f/task/' + ctrl.file.id, req).then(
					function success(resp) {
						ctrl.lmDone({result: resp.data});
					},
					serviceLimboMedia.handleHttpErrorNew
				);
			}
		};
	}
});
