/*
 * Params:
 * folder: folder object (required)
 */
lm.component('fileDialogFolderDelete', {
	templateUrl: 'comp/file/fileDialogFolderDelete.' + lmCacheTag + 'html',
	bindings: { lmParams: '<', lmDismiss: '&', lmDone: '&' },
	controller: function($http, serviceLimboMedia) {
		var ctrl = this;

		ctrl.folder = null;
		ctrl.showBindInfo = false;
		ctrl.working = false;
		
		ctrl.$onInit = function() {
			if(!ctrl.lmParams.folder) {
				console.log("No folder param. Closing.");
				ctrl.lmDismiss();
				return;
			}
			ctrl.folder = ctrl.lmParams.folder;
			ctrl.showBindInfo = ctrl.folder.fspath != null && ctrl.folder.fspath != '';
		}
		
		ctrl.deleteFolder = function() {
			ctrl.working = true;
			
			$http.delete(lmBase.url + 'f/folder/' + ctrl.folder.id).then(
				function success(resp) {
					ctrl.lmDone();
				},
				function error(resp) {
					serviceLimboMedia.handleHttpErrorNew(resp);
					ctrl.lmDone();
				}
			);
		};
		
		ctrl.unbindFolder = function() {
			ctrl.working = true;

			$http.post(lmBase.url + 'f/folder/' + ctrl.folder.id + '/unbind').then(
				function success(resp) {
					ctrl.lmDone();
				},
				function error(resp) {
					serviceLimboMedia.handleHttpErrorNew(resp);
					ctrl.lmDone();
				}
			);
		};
		
	}
});
