/*
 * Params:
 * id: Folder id (null=create, given=update)
 * parentId: Parent folder id to create new folder within, 0 for root folder. (required for create)
 * Output:
 * result: created/updated folder
 */
lm.component('fileDialogFolderEdit', {
	templateUrl: 'comp/file/fileDialogFolderEdit.' + lmCacheTag + 'html',
	bindings: { lmParams: '<', lmDismiss: '&', lmDone: '&' },
	controller: function($element, $http, serviceLimboMedia, serviceNotification) {
		var ctrl = this;
		
		ctrl.folderId = null;
		ctrl.folderParentId = null;
		ctrl.folder = null;

		ctrl.loadFolder = function() {
			$http.get(lmBase.url + 'f/folder/' + ctrl.lmParams.id).then(
				function(resp) {
					ctrl.folder = resp.data;
				},
				function(error) {
					ctrl.lmDismiss();
					serviceLimboMedia.handleHttpErrorNew(error);
				}
			);
		};
		
		ctrl.$onInit = function() {
			ctrl.folderId = ctrl.lmParams.id;
			ctrl.folderParentId = ctrl.lmParams.parentId;
			if(ctrl.folderId) {
				ctrl.loadFolder();
			}
			else {
				ctrl.folder = {name: '', parent: ctrl.folderParentId};
			}
		};
		
		ctrl.save = function() {
			if(ctrl.folderId) {
				$http.post(lmBase.url + 'f/folder/' + ctrl.folder.id, ctrl.folder).then(
					function success(resp) {
						ctrl.lmDone({result: resp.data});
					},serviceLimboMedia.handleHttpErrorNew
				);
			}
			else {
				$http.post(lmBase.url + 'f/folder', ctrl.folder).then(
					function success(resp) {
						ctrl.lmDone({result: resp.data});
					},serviceLimboMedia.handleHttpErrorNew
				);
			}
		};
		
	}
});
