/*
 * Params:
 * file: File to edit
 * readonly: 
 * Output:
 * result: none
 */
lm.component('fileDialogText', {
	templateUrl: 'comp/file/fileDialogText.' + lmCacheTag + 'html',
	bindings: { lmParams: '<', lmDismiss: '&', lmDone: '&' },
	controller: function($element, $http, serviceLimboMedia, serviceNotification) {
		var ctrl = this;

		ctrl.file = null;
		ctrl.fileText = null;
		ctrl.content = '';
		ctrl.readonly = false;

		/* settings */
		ctrl.settings = {};
		ctrl.loadSettings = function() {
			ctrl.settings = serviceLimboMedia.getRemoteSettings('appEditor');
			if(ctrl.settings.charset == null) ctrl.settings.charset = lmBase.charsets[0];
		};
		ctrl.saveSettings = function() {
			serviceLimboMedia.saveRemoteSettings('appEditor');
		};
		ctrl.aCharsets = lmBase.charsets.slice();
		
		/* lifecycle */
		ctrl.$onInit = function() {
			ctrl.loadSettings();
			if(ctrl.lmParams.readonly) {
				ctrl.readonly = true;
			}
			if(ctrl.lmParams.file) {
				ctrl.file = ctrl.lmParams.file;
				ctrl.loadContent();
			}
		};
		
		ctrl.loadContent = function() {
			$http.get(lmBase.url + 'f/file/' + ctrl.file.id + '/text?charset=' + ctrl.settings.charset).then(
				function success(resp) {
					ctrl.fileText = resp.data;
					ctrl.content = ctrl.fileText.content;
				}, serviceLimboMedia.handleHttpErrorNew
			);
		};
		
		ctrl.reset = function() {
			ctrl.loadContent();
		};
		
		ctrl.save = function() {
			var req = {content: ctrl.content, charset: ctrl.settings.charset};
			$http.post(lmBase.url + 'f/file/' + ctrl.file.id + '/text',req).then(
				function success(resp) {
					// serviceNotification.ok('MSG_SAVED');
					ctrl.lmDone({result: null});
				}, serviceLimboMedia.handleHttpErrorNew
			);
		};
		
	}
});
