lm.component('lmPdfPage', {
	templateUrl: 'comp/generic/lmPdfPage.' + lmCacheTag + 'html',
	bindings: {
		model: '<',
		scale: '<'
	},
	controller: function($scope, $element, $http, $translate, serviceLimboMedia, serviceNotification, serviceDeps) {
		var ctrl = this;
	  
		ctrl.elPage = $element[0];
		ctrl.elPageContainer = ctrl.elPage.parentElement;
		ctrl.elPagesContainer = ctrl.elPageContainer.parentElement;
		
		ctrl.elCanvas = ctrl.elPage.getElementsByClassName('pdfcanvas')[0];
		ctrl.canvas = ctrl.elCanvas;
		ctrl.canvasContext = ctrl.canvas.getContext('2d');
	  
		ctrl.renderTask = null;
		
		ctrl.resizer = null;
		
		/*
		console.log("Screen size: " + window.screen.width + "x" + window.screen.height);
		console.log("Window size: " + window.innerWidth + "x" + window.innerHeight);	// viewport
		console.log("Document size: " + document.documentElement.clientWidth + "x" + document.documentElement.clientHeight);
		console.log("elPage size          : " + ctrl.elPage.clientWidth + "x" + ctrl.elPage.clientHeight);
		console.log("elPageContainer size : " + ctrl.elPageContainer.clientWidth + "x" + ctrl.elPageContainer.clientHeight, ctrl.elPageContainer);
		console.log("elPagesContainer size: " + ctrl.elPagesContainer.clientWidth + "x" + ctrl.elPagesContainer.clientHeight, ctrl.elPagesContainer);
		*/
		
		ctrl.$onInit = function() {};

		ctrl.$postLink = function() {
			/* TODO CHECK HOW TO USE
			ctrl.resizer = new ResizeObserver(entries => {
				for (let entry of entries) {
					const cr = entry.contentRect;
					console.log('Element:', entry.target);
					console.log(`Element size: ${cr.width}px x ${cr.height}px`);
					console.log(`Element padding: ${cr.top}px ; ${cr.left}px`);
					// ctrl.render();
				}
			});
			ctrl.resizer.observe(ctrl.elPageContainer);
			*/
		};
	  
		ctrl.render = function() {
			if(!ctrl.model) {
				return;
			}

			var viewportOriginal = ctrl.model.getViewport(1);
			var viewportTarget = null;
			
			// PDF page dimensions
			var pdfWidth  = viewportOriginal.width;
			var pdfHeight = viewportOriginal.height;
			var pdfAspect = pdfWidth / pdfHeight;
			
			// Parent container defining available space
			var spaceWidth  = ctrl.elPageContainer.clientWidth;
			var spaceHeight = ctrl.elPageContainer.clientHeight;
			var spaceAspect = spaceWidth / spaceHeight;
			
			// console.log("Dimensions PDF  : ", pdfWidth + "x" + pdfHeight + ", Aspect: " + pdfAspect);
			// console.log("Dimensions Space: ", spaceWidth + "x" + spaceHeight + ", Aspect: " + spaceAspect);

			if(ctrl.scale == 'SCALE_FULL') {
				// Full width
				var scaleBy = spaceWidth / pdfWidth;
				viewportTarget = ctrl.model.getViewport(scaleBy);
			}
			else if(ctrl.scale == 'SCALE_ORIGINAL') {
				// Original size
				viewportTarget = viewportOriginal;
			}
			else {
				// Fit-space calculation
				if(pdfAspect > spaceAspect) {
					var scaleBy = spaceWidth / pdfWidth;
					viewportTarget = ctrl.model.getViewport(scaleBy);
				}
				else {
					var scaleBy = spaceHeight / pdfHeight;
					viewportTarget = ctrl.model.getViewport(scaleBy);
				}
			}

			// Prepare canvas using PDF page dimensions
			ctrl.canvas.height = viewportTarget.height;
			ctrl.canvas.width = viewportTarget.width;
		  
			// Render PDF page into canvas context
			var renderContext = {canvasContext: ctrl.canvasContext, viewport: viewportTarget};
		  
			if(ctrl.renderTask) {
				ctrl.renderTask.then(function() {
					ctrl.renderTask = ctrl.model.render(renderContext);  
				});
			}
			else {
				ctrl.renderTask = ctrl.model.render(renderContext);
			}

			ctrl.renderTask.then(function () {
				// console.log('Page rendered');
			});
		};
	  
		ctrl.$onChanges = function(cobj) {
			if(cobj.model) {
				ctrl.render();
			}
			if(cobj.scale) {
				ctrl.render();
			}
		};
	}
});
