lm.component('homeBoxFiles', {
	templateUrl: 'comp/home/homeBoxFiles.' + lmCacheTag + 'html',
	bindings: {
		box: '<',
		cbFrame: '&'	// Callback to modify surrounding Frame
	},
	controller: function($http, serviceLimboMedia, serviceFile, $rootRouter, $translate) {
		var ctrl = this;
		ctrl.serviceFile = serviceFile;

		ctrl.error = null;
		
		ctrl.folder = null;
		ctrl.files = [];
		ctrl.folders = [];
		
		ctrl.onTitleClick = function() {
			$rootRouter.navigate(['FilesAndMedia', {id: ctrl.folder.id}]);
		};
		
		ctrl.loadItems = function() {
			var par = {
				withFolder: true,
				withFolders: true,
				withFiles: true
			};

			$http.get(lmBase.url + 'f/folder/' + ctrl.box.folderId + '/mix', {params : par}).then(
				function success(resp) {
					ctrl.folder = resp.data.folder;
					resp.data.files.forEach(file => lmBase.pimpLmFile(file));
					ctrl.files = resp.data.files;
					ctrl.folders = resp.data.folders;
					ctrl.cbFrame({title: resp.data.folder.name, titleClickHandler: ctrl.onTitleClick});
				},
				function error(resp) {
					$translate(['FILES', 'ERROR', 'FOLDER_FETCH_ERROR']).then(function (translation) {
						ctrl.cbFrame({title: translation['FILES']});
						ctrl.error = translation['ERROR'] + ": " + translation['FOLDER_FETCH_ERROR'];
					});
				}
			);
		}
		
		ctrl.callbackFilesChanged = {
			onRemove: function(itemRemoved) {
				var idx = ctrl.files.indexOf(itemRemoved);
				if(idx != -1) {
					ctrl.files.splice(idx,1);	
				}
			},
			onChange: function(itemOriginal, itemChanged) {
				lmBase.pimpLmFile(itemChanged);
				var idx = ctrl.files.indexOf(itemOriginal);
				if(idx != -1) {
					ctrl.files[idx] = itemChanged;
				}
			}
		};		
		
		ctrl.$onInit = function() {
			if(ctrl.box.type != 'FILES' && ctrl.box.type != 'filesBox') {
				return;
			}
			ctrl.loadItems();
		};		
		
	}
});