/*
 * Params:
 * box: box to edit, otherwise create
 * Output:
 * result: ?
 */
lm.component('homeDialogBox', {
	templateUrl: 'comp/home/homeDialogBox.' + lmCacheTag + 'html',
	bindings: { lmParams: '<', lmDismiss: '&', lmDone: '&' },
	controller: function($http, serviceLimboMedia) {
		var ctrl = this;
		
		// Box type
		ctrl.boxTypes = ['NEWS', 'FILES'];				// Available box types
		ctrl.boxType = null;							// Selected box type
		ctrl.boxTypeChanged = function() {
		};
		
		// News
		ctrl.newsCreate = function() {
			var box = {type: 'NEWS'};
			ctrl.lmDone({result: box});
		};
		
		// Files
		ctrl.filesFolderInit = null;	// FolderId to init
		ctrl.filesFolderSelected = null;
		ctrl.filesFolderChanged = function(thefolder) {
			ctrl.filesFolderSelected = thefolder;
		};
		ctrl.filesCreate = function() {
			if(!ctrl.filesFolderSelected) return;
			var box = {
				type: 'FILES',
				folderId: ctrl.filesFolderSelected.id
			};
			ctrl.lmDone({result: box});
		};

		ctrl.$onInit = function() {
			// Edit existing
			if(ctrl.lmParams.box) {
				var b = ctrl.lmParams.box;
				if(b.type == 'NEWS' || b.type == 'newsBox') {
					ctrl.boxType = 'NEWS';
				}
				if(b.type == 'FILES' || b.type == 'filesBox') {
					ctrl.filesFolderInit = ctrl.lmParams.box.folderId;
					ctrl.boxType = 'FILES';
				}
			}
			if(!ctrl.boxType) {
				ctrl.boxType = 'NEWS';
			}
		}
		
		ctrl.ok = function() {
			if('NEWS' == ctrl.boxType) ctrl.newsCreate();
			if('FILES' == ctrl.boxType) ctrl.filesCreate();
		};
  }
});
