lm.component('homePage', {
	templateUrl: 'comp/home/homePage.' + lmCacheTag + 'html',
	bindings: {},
	$canActivate: function($nextInstruction, $prevInstruction, serviceLimboMedia) {
		return serviceLimboMedia.isAuthenticated();
	},
	controller: function(serviceLimboMedia, serviceModal) {

		var ctrl = this;
		ctrl.settings = null;
		ctrl.boxes = [];

		ctrl.addFloaterClick = function(valEvent) {
			serviceModal.show('home-dialog-box').then(
				function(result) {
					if(result) {
						ctrl.boxes.push(result);
						ctrl.stateSave();
					}
				},
				function() { }
			);
		};
	  
	  /* box changing */
	  ctrl.boxUp = function(valueBox) {
			var idx = ctrl.boxes.indexOf(valueBox);
			if(idx < 1) return;
			var tmp = ctrl.boxes[idx];
			ctrl.boxes[idx] = ctrl.boxes[idx - 1];
			ctrl.boxes[idx - 1] = tmp;
			ctrl.stateSave();
		}

	  ctrl.boxDown = function(valueBox) {
			var idx = ctrl.boxes.indexOf(valueBox);
			if(idx >= (ctrl.boxes.length - 1)) return;
			var tmp = ctrl.boxes[idx];
			ctrl.boxes[idx] = ctrl.boxes[idx + 1];
			ctrl.boxes[idx + 1] = tmp;
			ctrl.stateSave();
		}

	  ctrl.boxDelete = function(valueBox) {
			var idx = ctrl.boxes.indexOf(valueBox);
			ctrl.boxes.splice(idx,1);
			ctrl.stateSave();
	  }

		ctrl.boxEdit = function(valueBox) {
			serviceModal.show('home-dialog-box',{box: valueBox}).then(
				function(result) {
					if(result) {
						var idx = ctrl.boxes.indexOf(valueBox);
						if(idx != -1) {
							ctrl.boxes[idx] = result;
							ctrl.stateSave();
						}
					}
				},
				function(err) {}
			);
		};
	  
	  /* settings */
	  ctrl.stateSave = function() {
		  serviceLimboMedia.saveRemoteSettings();
	  }
	  
	  ctrl.init = function() {
		  ctrl.settings = serviceLimboMedia.getRemoteSettings();
		  if(ctrl.settings.boxes == null) {
			  ctrl.settings.boxes = [];
			  ctrl.boxes = ctrl.settings.boxes;
			  ctrl.boxes.push({type: 'NEWS', name: 'LimboMedia News'});
		  }
		  else {
			// Filter legacy boxes:
			ctrl.settings.boxes = ctrl.settings.boxes.filter(box => {
				if(box.type == 'FILES' || box.type == 'NEWS' || box.type == 'IOT' || box.type == 'newsBox' || box.type == 'thingsBox') {
					return true;
				}
				return false;
			});
			ctrl.boxes = ctrl.settings.boxes;
		  }
	  }
	  
	  ctrl.init();
  }
});