lm.component('lmMediaControl', {
	templateUrl: 'comp/media/lmMediaControl.' + lmCacheTag + 'html',
	bindings: {
		// lmModel: '<'	// state object of serviceMediaPlayer
	},
	controller: function($scope, $element, serviceMediaPlayer, serviceFullscreen, serviceContext) {
		var ctrl = this;
		ctrl.lmModel = serviceMediaPlayer.state;
		ctrl.fsState = serviceFullscreen.state;
		
		ctrl.elementBarPosition = $element[0].getElementsByClassName('barPosition')[0];
		ctrl.elementBarVolume = $element[0].getElementsByClassName('barVolume')[0];
		
		ctrl.onPositionChange = function(newPos) {
			serviceMediaPlayer.changePosition(newPos);
		};
		
		ctrl.onVolumeChange = function(newVol) {
			serviceMediaPlayer.changeVolume(newVol);
		};
		
		ctrl.onToggleMute = function() {
			serviceMediaPlayer.toggleVolume();
		};
		
		ctrl.onToggleFullscreen = function() {
			serviceMediaPlayer.toggleFullscreen();
		};
		
		ctrl.onPlayPause = function() {
			serviceMediaPlayer.playPause();
		};
		
		ctrl.onReset = function() {
			serviceMediaPlayer.reset();
		};
		
		ctrl.onStop = function() {
			serviceMediaPlayer.stop();
		};
		
		ctrl.onFormatChange = function(format) {
			serviceMediaPlayer.changeFormat(format);
		};
		ctrl.onAudioStreamChange = function(as) {
			serviceMediaPlayer.changeAudioStream(as);
		};
		ctrl.onSubStreamChange = function(ss) {
			serviceMediaPlayer.changeSubStream(ss);
		};
		
		ctrl.contextAudio = function(valScope, valEvent) {
			serviceContext.show(valScope ? valScope : $scope, valEvent.target, 'comp/media/lmMediaControlContextAudio.' + lmCacheTag + 'html', {placement:'top', container: valEvent.target.parentElement});	
		};
		ctrl.contextSubtitle = function(valScope, valEvent) {
			serviceContext.show(valScope ? valScope : $scope, valEvent.target, 'comp/media/lmMediaControlContextSubtitle.' + lmCacheTag + 'html', {placement:'top', container: valEvent.target.parentElement});	
		};
		ctrl.contextVideo = function(valScope, valEvent) {
			serviceContext.show(valScope ? valScope : $scope, valEvent.target, 'comp/media/lmMediaControlContextVideo.' + lmCacheTag + 'html', {placement:'top', container: valEvent.target});	
		};
		
	}
});

