lm.component('lmMediaImager', {
	templateUrl: 'comp/media/lmMediaImager.' + lmCacheTag + 'html',
	bindings: {},
	controller: function($scope, $element, $animate, $http, $rootRouter, serviceLimboMedia, serviceFullscreen, serviceImager, serviceModal) {
		var ctrl = this;
		ctrl.serviceImager = serviceImager;
		ctrl.state = serviceImager.state;
		ctrl.fs = serviceFullscreen.state;

		ctrl.click = function(evt) {
			var result = lmBase.mouseInElement(evt);
			$scope.$apply(function() {
				if(result < 0.33) serviceImager.prev();
				else if(result > 0.66) serviceImager.next();
				else serviceImager.close();
			});
		};

		ctrl.fullscreen = function() {
			serviceFullscreen.toggleFullscreen(!serviceFullscreen.state.fullscreen, $element[0]);
		};
		
		ctrl.map = function() {
			if(serviceFullscreen.isFullscreen) {
				serviceFullscreen.toggleFullscreen(false, null);
			}
			serviceModal.show('file-dialog-map', {file: ctrl.state.file}, {maximize: true}).then(
				function(result) {},
				function() {}
			);
		};

		ctrl.$onInit = function() {
			$element[0].addEventListener('click', ctrl.click);
			$scope.$watch('$ctrl.state.file', function(newValue, oldValue) {
				if(newValue) {
					$animate.removeClass($element, 'lmHide', { });
				}
				else {
					$animate.addClass($element, 'lmHide', { });
				}
			});
		};
		
	}
});
