/*
 * Params:
 * id: user id (required)
 * Output:
 * result: updated user
 */
lm.component('systemDialogUserEdit', {
	templateUrl: 'comp/system/systemDialogUserEdit.' + lmCacheTag + 'html',
	bindings: { lmParams: '<', lmDismiss: '&', lmDone: '&' },
	controller: function($http, serviceLimboMedia) {
		var ctrl = this;

		ctrl.availableAuthorities = lmBase.authorities;
		ctrl.availableLanguages = [];
		
		ctrl.item = null;
		ctrl.authorities = [];

		ctrl.$onInit = function() {
			if(!ctrl.lmParams.id) {
				console.log("No user id param. Closing.");
				ctrl.lmDismiss();
				return;
			}
			
			/* load user details */
			$http.get(lmBase.url + 'userAdmin/user/' + ctrl.lmParams.id).then(
				function success(resp) {
					ctrl.item = resp.data;
					lmBase.multiSelectionInit(ctrl.authorities,ctrl.availableAuthorities,ctrl.item.authorities);
				},
				serviceLimboMedia.handleHttpErrorNew
			);
			
			/* load available languages */
			$http.get(lmBase.url + 'system/info').then(
				function success(resp) {
					ctrl.availableLanguages = resp.data.languages;
				},
				serviceLimboMedia.handleHttpErrorNew
			);
		};
		
		ctrl.ok = function() {
			var req = {name: ctrl.item.name, password: ctrl.item.password, language: ctrl.item.language, description: ctrl.item.description, enable: ctrl.item.enable}
			req.authorities = lmBase.multiSelectionGetSelected(ctrl.authorities);
			
			$http.post(lmBase.url + 'userAdmin/user/' + ctrl.item.id, req).then(
				function success(resp) {
					ctrl.lmDone({result: resp.data});
				},
				serviceLimboMedia.handleHttpErrorNew
			);		
		};		
	
	}
});
