lm.component('systemPageRrd', {
  templateUrl: 'comp/system/systemPageRrd.' + lmCacheTag + 'html',
  bindings: {
  },
  $canActivate: function($nextInstruction, $prevInstruction, serviceLimboMedia) {
	  return serviceLimboMedia.isAuthenticated();
  },
  controller: function($http, serviceLimboMedia, serviceNotification,serviceDeps) {
	  var ctrl = this;
	  
	  ctrl.groups = [];
	  ctrl.group = null;
		
		ctrl.favgroup = new Object();
		ctrl.favgroup.name = "--- Favorites ---";
		ctrl.favgroup.files = new Array();
		ctrl.group = ctrl.favgroup;
		ctrl.groups.push(ctrl.favgroup);
		
		ctrl.settings = null;
		
		ctrl.loadGroups = function() {
			$http.get(lmBase.url + 'rrd/groups').then(
				function success(resp) {
					for(y in resp.data) {
						var it = resp.data[y];
						ctrl.groups.push(it);
					}
					ctrl.extractFavs();
				},
				serviceLimboMedia.handleHttpErrorNew
			);
		};
		
		ctrl.extractFavs = function() {
			for(x in ctrl.groups) {
				var grp = ctrl.groups[x];
				for(y in grp.files) {
					var fi = grp.files[y];
					
					for(z in ctrl.settings.favs) {
						if(fi.id == ctrl.settings.favs[z]) {
							fi.fav = true;
							ctrl.favgroup.files.push(fi);
						}
					}
				}
			}
		};
			
		ctrl.favAdd = function(valueFile) {
			valueFile.fav = true;
			for(x in ctrl.favgroup.files) {
				if(valueFile.id == ctrl.favgroup.files[x].id) {
					return;
				} 
			}
			ctrl.favgroup.files.push(valueFile);
			ctrl.saveSettings();
		};
		
		ctrl.favRemove = function(valueFile) {
			valueFile.fav = false;
			for(x in ctrl.favgroup.files) {
				if(valueFile.id == ctrl.favgroup.files[x].id) {
					ctrl.favgroup.files.splice(x,1);
				} 
			}		
			ctrl.saveSettings();
		};
		
		ctrl.saveSettings = function() {
			ctrl.settings.favs.splice(0,ctrl.settings.favs.length);
			for(x in ctrl.favgroup.files) {
				ctrl.settings.favs.push(ctrl.favgroup.files[x].id);
			}
			serviceLimboMedia.saveRemoteSettings();
		};
		
		ctrl.init = function() {
			ctrl.settings = serviceLimboMedia.getRemoteSettings();
			if(ctrl.settings.favs == null) ctrl.settings.favs = [];
			ctrl.loadGroups();
		}
		
		ctrl.init();		
  }
});
