lm.component('systemPageSettings', {
  templateUrl: 'comp/system/systemPageSettings.' + lmCacheTag + 'html',
  bindings: {
  },
  $canActivate: function($nextInstruction, $prevInstruction, serviceLimboMedia) {
	  return serviceLimboMedia.isAuthenticated();
  },
  controller: function($http, serviceLimboMedia, serviceNotification) {
	  var ctrl = this;
	  
		ctrl.defaultmediaconverter = new Object();

		ctrl.availableAudioStandards = ['WEBM_VORBIS','MP3'];
		ctrl.availableVideoStandards = ['WEBM','MP4'];
		ctrl.availableVideoLayouts = ['P360','P720','P1080'];
		ctrl.audioStandards = new Array();
		ctrl.videoStandards = new Array();
		ctrl.videoLayouts = new Array();

		ctrl.loadDefaultMediaConverter = function() {
			$http.get(lmBase.url + 'fileConfig/mediaConverter').then(
				function success(resp) {
					ctrl.defaultmediaconverter = resp.data;
					lmBase.multiSelectionInit(ctrl.audioStandards,ctrl.availableAudioStandards,ctrl.defaultmediaconverter.audioStandards);
					lmBase.multiSelectionInit(ctrl.videoStandards,ctrl.availableVideoStandards,ctrl.defaultmediaconverter.videoStandards);
					lmBase.multiSelectionInit(ctrl.videoLayouts,ctrl.availableVideoLayouts,ctrl.defaultmediaconverter.videoLayouts);
				},
				serviceLimboMedia.handleHttpErrorNew
			);
		};
		
		ctrl.saveDefaultMediaConverter = function() {
			ctrl.defaultmediaconverter.audioStandards = lmBase.multiSelectionGetSelected(ctrl.audioStandards);
			ctrl.defaultmediaconverter.videoStandards = lmBase.multiSelectionGetSelected(ctrl.videoStandards);
			ctrl.defaultmediaconverter.videoLayouts = lmBase.multiSelectionGetSelected(ctrl.videoLayouts);
			
			$http.post(lmBase.url + 'fileConfig/mediaConverter',ctrl.defaultmediaconverter).then(
				function success(resp) {
					serviceNotification.ok('MSG_SAVED');
					ctrl.loadDefaultMediaConverter();
				},
				serviceLimboMedia.handleHttpErrorNew
			);
		};
		
		ctrl.fssync = new Object();

		ctrl.loadFssync = function() {
			$http.get(lmBase.url + 'fileConfig/filesystemSynchronization').then(
				function success(resp) {
					ctrl.fssync = resp.data;
				},
				serviceLimboMedia.handleHttpErrorNew
			);
		};
		
		ctrl.saveFssync = function() {
			$http.post(lmBase.url + 'fileConfig/filesystemSynchronization', ctrl.fssync).then(
				function success(resp) { 
					serviceNotification.ok('MSG_SAVED');
					ctrl.loadFssync();
				},
				serviceLimboMedia.handleHttpErrorNew
			);
		};
		
		ctrl.deleteConvertedImages = function() {
			$http.post(lmBase.url + 'fileConfig/deleteConvertedImages').then(
				function success(resp) {
					serviceNotification.ok('MSG_JOB_STARTED');
				},
				serviceLimboMedia.handleHttpErrorNew
			);
		};
		
		ctrl.deleteConvertedAudios = function() {
			$http.post(lmBase.url + 'fileConfig/deleteConvertedAudios').then(
				function success(resp) {
					serviceNotification.ok('MSG_JOB_STARTED');
				},
				serviceLimboMedia.handleHttpErrorNew
			);
		};
		
		ctrl.deleteConvertedVideos = function() {
			$http.post(lmBase.url + 'fileConfig/deleteConvertedVideos').then(
				function success(resp) {
					serviceNotification.ok('MSG_JOB_STARTED');
				},
				serviceLimboMedia.handleHttpErrorNew
			);
		};

		ctrl.extractAudioVideoCovers = function() {
			$http.post(lmBase.url + 'fileConfig/extractAudioVideoCovers').then(
				function success(resp) {
					serviceNotification.ok('MSG_JOB_STARTED');
				},
				serviceLimboMedia.handleHttpErrorNew
			);
		};

		ctrl.runFileSync = function() {
			$http.post(lmBase.url + 'fileConfig/runFileSync').then(
				function success(resp) {
					serviceNotification.ok('MSG_JOB_STARTED');
				},
				serviceLimboMedia.handleHttpErrorNew
			);
		};

		ctrl.runMediaConverter = function() {
			$http.post(lmBase.url + 'fileConfig/runMediaConverter').then(
				function success(resp) {
					serviceNotification.ok('MSG_JOB_STARTED');
				},
				serviceLimboMedia.handleHttpErrorNew
			);
		};
		
		ctrl.loadFssync();	
		ctrl.loadDefaultMediaConverter();

  }
});