lm.component('systemPageStats', {
	templateUrl: 'comp/system/systemPageStats.' + lmCacheTag + 'html',
	bindings: {},
	$canActivate: function($nextInstruction, $prevInstruction, serviceLimboMedia) {
		return serviceLimboMedia.isAuthenticated();
	},
	controller: function($http, serviceLimboMedia) {
		var ctrl = this;
		
		ctrl.lines = [];


	  ctrl.users = [];
		
	  ctrl.toggleExpand = function(line) {
		line.expand = !line.expand;
	  };
		
	  ctrl.loadUsers = function() {
			$http.get(lmBase.url + 'user/users').then(
				function success(resp) {
					ctrl.users = resp.data;
					
					var line = {user: {id: 0, name: '= ALL ='}};
					ctrl.lines.push(line);
					ctrl.loadStat(line);
					
					for(y in ctrl.users) {
						line = {user: ctrl.users[y]};
						ctrl.lines.push(line);
						ctrl.loadStat(line);
					}
				},
				serviceLimboMedia.handleHttpErrorNew
			);
		};	
		
		ctrl.loadStat = function(line) {
			$http.get(lmBase.url + 'stats/stats/' + line.user.id, {target: line}).then(
				function success(resp) {
					resp.config.target.data = resp.data;
					resp.config.target.size = 0;
					resp.config.target.items = 0;
					resp.config.target.expand = false;
					
					for(x in resp.data) {
						var dat = resp.data[x];
						if(dat.category == 'FILE' && dat.variant == 'FILE') {
							resp.config.target.items += dat.count;
						}
						else {
							resp.config.target.size += dat.sizeSum;
						}
					}
				},
				serviceLimboMedia.handleHttpErrorNew
			);	
		};
		
		ctrl.$onInit = function() {
			ctrl.loadUsers();
		};
  }
});