lm.component('lmUiPopper', {
  templateUrl: 'comp/ui/lmUiPopper.' + lmCacheTag + 'html',
  bindings: {
	  lmOutside: '<',		// Catch close events here. Defaults to document. Use for modals, etc.
	  lmPopPlace: '@',		// Placement, default bottom-end, check popper.js docs for valid values
	  lmPopFlip: '@'		// Flip if no space. Defaults to true.
  },
  transclude: {
      'slotTrigger': '?lmUixTrigger',
      'slotContent': 'lmUixContent'
  },
  controller: function($scope, $element, $http, $translate, $timeout, serviceLimboMedia, serviceNotification, serviceDeps) {
	  var ctrl = this;

	  ctrl.render = false;
	  ctrl.popper = null;
	  ctrl.listener = false;
	  
	  ctrl.$onInit = function() {
		  ctrl.lmPopPlace = ctrl.lmPopPlace || 'bottom-end';
		  ctrl.lmPopFlip = ctrl.lmPopFlip ? "true" == ctrl.lmPopFlip : true;
	  };
	  
	  ctrl.intPopperInit = function() {
		  // initialize or update popper
		  if(ctrl.popper) {
			  ctrl.popper.update();
		  }
		  else {
			  var elTrigger = $element.find('lm-uix-trigger').get(0);
			  var elContent = $element.find('.contentWrapper').get(0);
			  ctrl.popper = Popper.createPopper(elTrigger, elContent, {
			  placement: ctrl.lmPopPlace,
				  modifiers: [
					  {name: 'offset', options: {offset: [0, 4]}}
  				  ]
			  });
		  }
	  };

	  ctrl.clickTrigger = function($event) {
		  if(!ctrl.render) {
			  ctrl.render = true;
			  // trigger show in next cycle to catch same event for instant close. 
			  $timeout(function() {
				  ctrl.intPopperInit();
			  });
		  }
	  };

	  ctrl.clickBackdrop = function($event) {
		$event.preventDefault();
		ctrl.render = false;
	  };
	  
	  ctrl.$onDestroy = function() {
		  if(ctrl.popper) {
			  ctrl.popper.destroy();
		  }
	  };

  }
});
