lm.component('pageUserSettings', {
	templateUrl: 'comp/user/pageUserSettings.' + lmCacheTag + 'html',
	bindings: {},
	$canActivate: function($nextInstruction, $prevInstruction, serviceLimboMedia) {
		return serviceLimboMedia.isAuthenticated();
	},
	controller: function($scope, $http, serviceLimboMedia, serviceNotification, serviceUpload) {
		var ctrl = this;
	  
		/* Account details & settings */
		ctrl.user = serviceLimboMedia.userdetails.user;
		ctrl.languages = [];
		ctrl.language = ctrl.user.language;
		ctrl.trash = ctrl.user.trash;
  		
		ctrl.accountLoad = function() {
			$http.get(lmBase.url + 'system/info').then(
				function success(resp) {
					ctrl.languages = resp.data.languages;
					for(x in resp.data.languages) {
						var it = resp.data.languages[x];
						if(it.code == ctrl.user.language) {
							ctrl.language = it;
						}
					}
				},
				serviceLimboMedia.handleHttpErrorNew
			);
		};

		ctrl.accountSave = function() {
			var req = {language: ctrl.language.code, trash: ctrl.trash};
			
			$http.post(lmBase.url + 'user/user', req).then(
				function success(resp) {
					serviceLimboMedia.changeLang(ctrl.language.code);
				},
				serviceLimboMedia.handleHttpErrorNew
			);
		};

		/* Password */
		ctrl.pwchange = {old: '', neu: ''};
		ctrl.passwordSave = function() {
			var req = {passwordOld: ctrl.pwchange.old, passwordNew: ctrl.pwchange.neu};
			$http.post(lmBase.url + 'user/user', req).then(
				function success(resp) {
					serviceNotification.ok('MSG_RELOGIN');
				},
				serviceLimboMedia.handleHttpErrorNew
			);			
		};
	  
		/* Lifecycle */
		ctrl.$onInit = function() {
			ctrl.accountLoad();
		};
		
	}
});