lm.directive('lmRole', function(serviceLimboMedia, $animate) {
	return {
	    restrict: 'A',
	    multiElement: true,
	    link: function(scope, element, attr) {
	    	scope.userdetails = serviceLimboMedia.userdetails;
	    	scope.$watch('userdetails.user', function(value) {
				var hasit = serviceLimboMedia.hasRole(attr.lmRole);
				$animate[hasit ? 'removeClass' : 'addClass'](element, 'lmHide', { });
				// TODO $animate ??? available ???
	    	});
	    }
	  };
});

lm.directive('lmShowIn', function(serviceLimboMedia, $animate) {
	return {
	    restrict: 'A',
	    multiElement: true,
	    link: function(scope, element, attr) {
	    	scope.userdetails = serviceLimboMedia.userdetails;
	    	scope.$watch('userdetails.user', function(value) {
				$animate[value ? 'removeClass' : 'addClass'](element, 'lmHide', { });
	    	});
	    }
	  };
});

lm.directive('lmHideIn', function(serviceLimboMedia, $animate) {
	return {
	    restrict: 'A',
	    multiElement: true,
	    link: function(scope, element, attr) {
	    	scope.userdetails = serviceLimboMedia.userdetails;
	    	scope.$watch('userdetails.user', function(value) {
				$animate[value ? 'addClass' : 'removeClass'](element, 'lmHide', { });
	    	});
	    }
	  };
});

lm.directive('lmSrc', function(serviceLimboMedia, $animate) {
	return {
	    restrict: 'A',
	    multiElement: true,
	    priority: 99,
	    link: function(scope, element, attr) {
	    	var elImgReal = element[0];
	    	var elImgLoad = new Image();
	    	elImgLoad.onload = function() {
	    		elImgReal.src = elImgLoad.src;
	    	};
	    	
	    	var srcLoadImg = attr.lmLoader;

	        attr.$observe('lmSrc', function(value) {
	            if (!value) {
	            	elImgReal.src = '';
	            	return;
	            }

	            if(srcLoadImg) {
	            	elImgReal.src = srcLoadImg;
	            }

	            elImgLoad.src = value;
	            // As alternative we might use attr[attrName] value since $set can sanitize the url.
	          });
	    }
	
	  };
});

lm.directive('lmSensorgraph', function($http, serviceNotification) {
	
	function link(scope, element, attrs) {
		var sensordata;
	
		scope.$watch(attrs.lmSensorgraph, function(value) {
			sensordata = value;
			scope.drawFile();
      	});

		scope.drawFile = function() {
			if(sensordata == null) return;
			
			var sd = new Array();
			sd.push(sensordata);
			
			var graph = $.plot($(element), sd, {
				legend: {show:true, position:"ne",noColumns:1},
				lines: {show:true},
				xaxis: {
					mode: "time",
					timezone: "browser",
					timeformat: "%Y-%m-%d<br/>%H:%M:%S"
				},
				selection: { mode: "x" },
				tooltip: true,
				tooltipOpts: { content: "<h4>%s</h4> Value: %y.3<br/>%x" },
				grid: { hoverable: true }				
			});
		};
	};
    return { link: link };
});


lm.directive('lmFocus', function() {
	var focusTags = ['INPUT','TEXTAREA'];
	function link(scope, element, attrs) {
		var elFocus = null;
		var el1 = element[0];
		
		if(focusTags.includes(el1.tagName)) elFocus = el1;
		else {
			focusTags.forEach(el => {
				var el2 = el1.getElementsByTagName(el)[0];
				if(el2) elFocus = el2;
			});
		}
		if(elFocus) elFocus.focus();
	};
    return { link: link };
});
