lm.factory('serviceFile', ['$rootScope', '$rootRouter', '$http', 'serviceLimboMedia', 'serviceMediaPlayer', 'serviceImager', 'serviceModal', 'serviceNotification', 'serviceFileSelect', function($rootScope, $rootRouter, $http, serviceLimboMedia, serviceMediaPlayer, serviceImager, serviceModal, serviceNotification, serviceFileSelect) {
	var service = {};

	
	/* ================ */
	/* = FILE ACTIONS = */
	/* ================ */
	
	service.handleUpdatedFile = function(theNewFile, theOriginalFile, theList) {
		if(theNewFile) {
			lmBase.pimpLmFile(theNewFile);
			if(theList) {
				var idx = theList.indexOf(theOriginalFile);
				if(idx != -1) {
					theList[idx] = theNewFile;
				}
			}
		}
		return theNewFile;
	};
	
	// TODO - Thing about reject switch: handle and forget, handle and pass, own handler instead
	service.taskToggle = function(theFile, callback) {
		var req = {title: theFile.title, done: !theFile.done};
		return $http.post(lmBase.url + 'f/task/' + theFile.id, req).then(
			function(resp) {
				if(callback) {
					callback.onChange(theFile, resp.data);
				}
			},
			serviceLimboMedia.handleHttpErrorNew
		);
	};	
	
	service.fileEdit = function(theFile, callback) {
		var dialog = 'file-dialog-file-edit';
		var max = false;
		
		if('LINK' === theFile.type) dialog = 'file-dialog-file-link-edit';
		if('NOTE' === theFile.type) {
			dialog = 'file-dialog-file-note-edit';
			max = true;
		}
		if('TASK' === theFile.type) dialog = 'file-dialog-file-task-edit';
		if('STREAM' === theFile.type) dialog = 'file-dialog-file-stream-edit';

		return serviceModal.show(dialog,{id: theFile.id}, {maximize: max}).then(
			function(result) {
				if(result && callback) {
					callback.onChange(theFile, result);
				}
			},
			function() {}
		);
	};
	
	service.fileDelete = function(theFile, callback) {
		var prom = $http.delete(lmBase.url + 'f/file/' + theFile.id);
		prom.then(
			function success(resp) {
				callback.onRemove(theFile);
			},
			serviceLimboMedia.handleHttpErrorNew
		);
		
		// Working blocker for files > 100mb. Actually relevant for move-to-trash.
		if(theFile.size > 100000000) {
			serviceNotification.showWorking(prom);
		}
		
		return prom;
	};

	service.fileDownload = function(theFile) {
		var ifrm = document.getElementById('downloadframe');
		ifrm.src = lmBase.url + 'f/stream/' + theFile.id + '/' + theFile.name;
	};
	
	service.fileMap = function(theFile) {
		serviceModal.show('file-dialog-map', {file: theFile}, {maximize: true}).then(
			function(result) {},
			function() {}
		);
	};

	service.filePdf = function(theFile) {
		serviceModal.show('file-dialog-pdf', {file: theFile}, {maximize: true}).then(
			function(result) {},
			function() {}
		);
	};
	
	service.fileText = function(theFile, writable) {
		serviceModal.show('file-dialog-text', {file: theFile, readonly: !writable}, {maximize: true}).then(
			function(result) {},
			function() {}
		);
		// TODO react to file-type change if content has changed and scan leads to another type
	};
	
	service.fileDefaultAction = function(theFile, theList, writable, callback) {
		if('TASK' === theFile.type) service.taskToggle(theFile, callback);
		else if('LINK' == theFile.type) window.open(theFile.url, '_blank').focus();
		else if('AUDIO' == theFile.type || 'VIDEO' == theFile.type || 'STREAM' == theFile.type) serviceMediaPlayer.addPlayFile(theFile);
		else if('NOTE' == theFile.type) service.fileEdit(theFile, callback);
		else if(lmBase.isFilePdf(theFile)) service.filePdf(theFile);
		else if('IMAGE' == theFile.type) serviceImager.openImages(theFile, theList, !!writable, callback);
		else if(lmBase.isFileText(theFile)) service.fileText(theFile, !!writable);
		else service.fileDownload(theFile);
	};


	/* ================== */
	/* = FOLDER ACTIONS = */
	/* ================== */
	
	service.folderMap = function(theFolder) {
		serviceModal.show('file-dialog-map', {folderId: theFolder.id}, {maximize: true}).then(
			function(result) {},
			function() {}
		);
	};
	
	service.folderDownload = function(theFolder) {
	    var filename = 'LimboDownload_' + encodeURIComponent(theFolder.name) + ".zip";
	    var ifrm = document.getElementById('downloadframe');
    	ifrm.src = lmBase.url + 'f/folder/' + theFolder.id + '/zip/' + filename;
	};
	
	
	return service;
}]);
